CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  CANNON1_PIN   = 26
  CANNON2_PIN   = 24
  CANNON3_S_PIN = 27 ' in place of 3, a servo

  ' cannon servo parms =======
  'CANNON_S_INITIAL= 1982
  CANNON_S_FINAL  = 1800

  ' attack cts =========

  SHOOT_WAIT_TIME = 1200  
  SHOOT_THRESH    = 10
  LONG_TURN       = 200 'was 200
  SHORT_TURN      = 10
  FWD_TIME        = 300
  REV_TIME        = 100

  IRBL_PIN        = 0
  IRL_PIN         = 1
  IRFL_PIN        = 2  
  IRFR_PIN        = 3
  IRR_PIN         = 4
  IRBR_PIN        = 5 

  SPEED           = 75

  ' #1,HUNT_NOTHING, HUNT_FRONT, HUNT_LEFT, HUNT_RIGHT, HUNT_SHOOT, HUNT_CHASE

  #1, IR_NOTHING, IR_LEFT, IR_LEFT_FRONT, IR_RIGHT, IR_RIGHT_FRONT, IR_LOCK

  OUT = 1

  SERVO_ENABLED = true

OBJ
  irdet  : "irdetect"
  servos : "Servo32" ' servos contol, 1 cog
  clk    : "clock"
 
VAR
  long stackATK[120]                         
  byte hunt_ctr, meneo, ir_detect_state
  long ir_detect_state_ptr
  long ir_detect_ctr_ptr
  long ir_detect_ptr
  long beh_ctrl_ptr
  long motorL_ptr
  long motorR_ptr
  long messages_ptr
  long msg_disabled
  long msg_FR
  long msg_R
  long msg_L
  long msg_FL
  long msg_rev
  long msg_lock
  long msg_forward
  long msg_shoot
  long msg_shoot1
  long msg_shoot2
  long msg_shoot3
  long msg_pursuit
  long bullets_left 
  long attack_accumulator

PUB start(ir_detect_state_ptr_, ir_detect_ctr_ptr_, ir_detect_ptr_, beh_ctrl_ptr_, motorL_ptr_, motorR_ptr_, messages_ptr_) 
  ir_detect_state_ptr := ir_detect_state_ptr_
  ir_detect_ctr_ptr   := ir_detect_ctr_ptr_
  ir_detect_ptr       := ir_detect_ptr_
  beh_ctrl_ptr        := beh_ctrl_ptr_
  motorL_ptr          := motorL_ptr_
  motorR_ptr          := motorR_ptr_
  messages_ptr        := messages_ptr_
  ' servos.Set(CANNON3_S_PIN, CANNON_S_INITIAL)  
  ' servos.Start ' servo.set BEFORE servos.start

  msg_disabled := string("disabled          ")
  msg_FL       := string("front left        ")
  msg_L        := string("left              ")      
  msg_R        := string("right             ")      
  msg_FR       := string("front right       ")      
  msg_rev      := string("reverse           ")
  msg_pursuit  := string("pursuit           ")
  msg_shoot    := string("shoot             ")
  msg_shoot1   := string("shoot 2           ")
  msg_shoot2   := string("shoot 3           ")
  msg_shoot3   := string("shoot 3           ")
  msg_lock     := string("lock              ")

  long[ir_detect_state_ptr] := IR_NOTHING

  clk.init(_xinfreq)
  cognew(attack, @stackATK)

PRI attack | i, ir_state, diff, absdiff
  dira[CANNON1_PIN]   := OUT
  dira[CANNON2_PIN]   := OUT
  dira[CANNON3_S_PIN] := OUT

  bullets_left := 3

  repeat
    repeat i from 0 to irdet#MAX_IR_SENSORS - 1
      long[ir_detect_ptr][i] := (long[ir_detect_ctr_ptr][i] > irdet#IR_PULSE_THRESH)

    if long[ir_detect_ptr][IRFL_PIN] and long[ir_detect_ptr][IRFR_PIN]
      diff := long[ir_detect_ptr][IRFL_PIN] - long[ir_detect_ptr][IRFR_PIN]
      absdiff := ||diff
      long[beh_ctrl_ptr] := 1
      long[messages_ptr] := msg_lock
      if absdiff < 5 
        ir_state := IR_LOCK
        attack_accumulator := 0
        repeat 5
          if long[ir_detect_ptr][IRFL_PIN] and long[ir_detect_ptr][IRFR_PIN]
            attack_accumulator++
          clk.pausemsec(5)
        if attack_accumulator > 3
          shoot

      elseif diff > 0 ' more left
        ir_state := IR_LEFT_FRONT 
        long[messages_ptr] := msg_FL
        hard_left(5)
      else
        long[messages_ptr] := msg_FR
        ir_state := IR_RIGHT_FRONT 
        hard_right(5)


      {if long[ir_detect_ptr][IRR_PIN] 
        ir_state := IR_RIGHT_FRONT
        hard_right(SHORT_TURN)
      elseif long[ir_detect_ptr][IRL_PIN]
        ir_state := IR_LEFT_FRONT
        hard_left(SHORT_TURN)
      else
        ir_state := IR_LOCK
        attack_accumulator += 2
        if attack_accumulator > SHOOT_THRESH
          shoot
          attack_accumulator := 0
        }

    elseif long[ir_detect_ptr][IRR_PIN]
      long[messages_ptr] := msg_FR
      ir_state := IR_RIGHT_FRONT
      hard_right(SHORT_TURN)
      'if attack_accumulator > 0
      '  attack_accumulator--

    elseif long[ir_detect_ptr][IRL_PIN]
      ir_state := IR_LEFT_FRONT
      long[messages_ptr] := msg_FL
      hard_left(SHORT_TURN)
      'if attack_accumulator > 0
      '  attack_accumulator--

    elseif long[ir_detect_ptr][IRBR_PIN]
      ir_state := IR_RIGHT
      long[messages_ptr] := msg_R
      hard_right(LONG_TURN)
      attack_accumulator := 0

    elseif long[ir_detect_ptr][IRBL_PIN] 
      ir_state := IR_LEFT 
      long[messages_ptr] := msg_L
      hard_left(LONG_TURN)
      attack_accumulator := 0

    else 
      ir_state := IR_NOTHING
      long[messages_ptr] := msg_disabled
      attack_accumulator := 0
      disable

    long[ir_detect_state_ptr] := ir_state
      

PRI shoot 
  case bullets_left
    0: 
      'chase
      long[messages_ptr] := msg_pursuit
      forward(0)
    3: 
      long[messages_ptr] := msg_shoot1
      if SERVO_ENABLED
      ' note: cannon servo is physically in place of cannon 3
      ' but we'sll shoot it 1st
        'servos.Set(CANNON3_S_PIN, CANNON_S_INITIAL)  
        servos.set(CANNON3_S_PIN, CANNON_S_FINAL)
        servos.Start ' servo.set BEFORE servos.start
        clk.pausemsec(250)
        servos.set(CANNON3_S_PIN, 0)


      clk.pausemsec(250)
      clk.pausemsec(SHOOT_WAIT_TIME)
      bullets_left--
    2:
      long[messages_ptr] := msg_shoot2
      outa[CANNON1_PIN] := 1
      clk.pausemsec(25)
      outa[CANNON1_PIN] := 0
      clk.pausemsec(SHOOT_WAIT_TIME)
      bullets_left--
    1:
      long[messages_ptr] := msg_shoot3
      outa[CANNON2_PIN] := 1
      clk.pausemsec(25)
      outa[CANNON2_PIN] := 0
      clk.pausemsec(SHOOT_WAIT_TIME)
      bullets_left--

PRI forward(bias)
  long[beh_ctrl_ptr] := 1
  long[motorL_ptr] := SPEED
  long[motorR_ptr] := SPEED
  clk.pausemsec(FWD_TIME)

PRI reverse
  long[beh_ctrl_ptr] := 1
  long[motorL_ptr] := long[motorR_ptr] := -SPEED
  'clk.pausemsec(REV_TIME)

PRI hard_right(t)
  long[beh_ctrl_ptr] := 1
  long[motorL_ptr] := SPEED
  long[motorR_ptr] := -SPEED
  clk.pausemsec(t)            
  'short_stop

PRI hard_left(t)
  long[beh_ctrl_ptr] := 1
  long[motorL_ptr] := -SPEED
  long[motorR_ptr] := SPEED
  clk.pausemsec(t)            
  'short_stop

PRI disable
  long[beh_ctrl_ptr] := 0
  long[motorL_ptr] := long[motorR_ptr] := 0
 
PRI short_stop
  long[beh_ctrl_ptr] := 1            
  long[motorL_ptr] := long[motorR_ptr] := 0
  clk.pausemsec(20)

PRI stop
  long[beh_ctrl_ptr] := 1            
  long[motorL_ptr] := long[motorR_ptr] := 0
'00 06 80 80 01 00  n
'00 00 80 80 80 00
'00 00 00 70 70 00
'00 80 99 80 00 00 
'00 80 00 39 00 00
'
'n 15cm  
'n-30deg 
'n-45deg 
'n+30deg 
'n+45deg 
