CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  
  IR_PULSE_COUNT_THRESH = 40
  MAX_BEH = 3
  #0, ESCAPE_BEH, HUNT_BEH, NAV_BEH   
  '-------------------------------------------------------------------------
  ' Pin defs
  GLED_PIN = 19
  RLED_PIN = 23
  '-------------
  IRBL_PIN = 1
  IRL_PIN =  2
  IRFL_PIN = 3  
  IRFR_PIN = 4
  IRR_PIN =  5
  IRBR_PIN = 6                
  '
  OUT = 1
  IN = 0
  MIN_CNT = 400 ' minimum value for waitcnt
  '------------------
  DEBOUNCE_THRESH = 20  ' for switches
  IR_FREQ = 466
  MAX_IR_SENSORS = 6
  MAX_IR_CTR = 2
  IR_PULSE_THRESH = 10
  IR_MEASURE_TIME = 50
  ' location of ir info
  #0, IRBL, IRL, IRFL, IRFR, IRR, IRBR
  #1, IR_NOTHING, IR_LEFT, IR_LEFT_FRONT, IR_RIGHT, IR_RIGHT_FRONT, IR_LOCK
  '-------------------------------------------------------------------------

OBJ
  bs2 : "BS2_Functions"
  lcd : "Debug_Lcd"

VAR
  long messages[MAX_BEH]
  ' ir detection 
  long freq[MAX_IR_SENSORS]
  byte ir_pins[MAX_IR_SENSORS]
  byte ir_detect[MAX_IR_SENSORS]
  long ir_detect_ctr[MAX_IR_SENSORS]
 

PUB Main | c,range,blinky,i

  '-------- Startup routines
  startup
  repeat i from 0 to 3
    lcd.clrln(i)
  debugIR_draw_lcd
    
PRI startup | okay
  ir_pins[IRBL] := IRBL_PIN
  ir_pins[IRL] := IRL_PIN
  ir_pins[IRFL] := IRFL_PIN
  ir_pins[IRFR] := IRFR_PIN  
  ir_pins[IRR] := IRR_PIN
  ir_pins[IRBR] := IRBR_PIN
  bs2.start(31,30)  
  lcd.init(15,19200,4)
  lcd.backlight(true)
  lcd.cls
    
PRI debugIR_draw_lcd | i
  lcd.cls
  repeat i from 0 to MAX_IR_SENSORS - 1
    dira[ir_pins[i]] := IN
  ' 0 =bl
  ' 1
  repeat  
    lcd.home
    lcd.decx(bs2.count(0,100),2)      
    lcd.putc(" ")    