CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  
  '-------------------------------------------------------------------------
  ' Pin defs
  RLED_PIN = 27
  YLED_PIN = 25
  ODOM_R_PIN = 12
  '-------------
  OUT = 1
  IN = 0
  MIN_CNT = 400 ' minimum value for waitcnt
  PORT_A = 0
  '------------------

OBJ
  clk: "Clock"
  bs2 : "BS2_Functions"
  lcd : "Debug_Lcd"

VAR
  long stackWW[80]
  long wheelctrR, wheelctrL
 

PUB main 
  clk.init(_XINFREQ)
  clk.pausemsec(250)
  startup
  cognew(wheel_watcher, @stackWW)
  repeat
    draw_lcd
    
PRI startup
  dira[RLED_PIN] := OUT
  led_startup(RLED_PIN)
  bs2.start(31,30)  
  lcd.init(15,19200,4)
  lcd.backlight(true)
  lcd.cls
  lcd.str(string("bootup OK"))
  clk.pausesec(1)
  lcd.cls

PRI led_startup(pin)
  repeat 3
    outa[pin] := 1
    clk.pausemsec(250)
    outa[pin] := 0
    clk.pausemsec(250)

PRI wheel_watcher | right, state, msk
  dira[YLED_PIN] := OUT
  dira[ODOM_R_PIN] := IN
  wheelctrR := wheelctrL := 0
  msk := |< ODOM_R_PIN
  state := ina    
  repeat
    waitpne(state, msk, PORT_A)
    outa[YLED_PIN] := ina[ODOM_R_PIN]
    'wheelctrR++
    state := ina
    
PRI draw_lcd  
  lcd.home
  lcd.decx(wheelctrR, 2)      
  lcd.putc(" ")    