CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  CANNON1_PIN   = 26
  CANNON2_PIN   = 24
  CANNON3_S_PIN = 27 ' in place of 3, a servo

  ' cannon servo parms =======
  CANNON_S_INITIAL= 1982
  CANNON_S_FINAL  = 1200

  ' attack cts =========

  SHOOT_WAIT_TIME = 1200  
  SHOOT_THRESH    = 10

  OUT = 1

OBJ
  servos : "Servo32" ' servos contol, 1 cog
  clk    : "clock" 
 

VAR
  long bullets_left

PUB main
  dira[CANNON1_PIN]   := OUT
  dira[CANNON2_PIN]   := OUT
  dira[CANNON3_S_PIN] := OUT

  servos.Set(CANNON3_S_PIN, CANNON_S_INITIAL)  
  servos.Start ' servo.set BEFORE servos.start
          
  clk.init(_xinfreq)
  clk.pausemsec(100) ' some time to settle

  bullets_left := 3
  repeat 3
    shoot
    clk.pausemsec(500)


PRI shoot 
  case bullets_left
    '0: 
      'chase
      'forward(0)
    1:       
      ' note: cannon servo is physically in place of cannon 3
      ' but we'sll shoot it 1st
      ' servos.set(CANNON3_S_PIN, CANNON_S_FINAL)

      clk.pausemsec(250)
      clk.pausemsec(SHOOT_WAIT_TIME)
      bullets_left--
    2:
      
      outa[CANNON1_PIN] := 1
      clk.pausemsec(25)
      outa[CANNON1_PIN] := 0
      clk.pausemsec(SHOOT_WAIT_TIME)
      bullets_left--
      
    3:
      outa[CANNON2_PIN] := 1
      clk.pausemsec(25)
      outa[CANNON2_PIN] := 0
      clk.pausemsec(SHOOT_WAIT_TIME)
      bullets_left--
 