CON
  ODOM_R_PIN    = 12
  ODOM_L_PIN    = 13
  IN = 0
  ' WHEEL_DEBOUNCE  = 5_000_000
  WHEEL_DEBOUNCE  = 200

  SPEED_SAMPLING_INTERVAL = 20_000_000
  MAX_TICKS_PER_S = 32

VAR
  long wwStack[80]
  long speedL_ptr, speedR_ptr

PUB start(speedL_ptr_, speedR_ptr_)
  speedR_ptr := speedR_ptr_
  speedL_ptr := speedL_ptr_
  cognew(wheel_watcher, @wwStack)
  
PRI wheel_watcher | stateL, stateR, last_changeR, last_changeL, wheelR_ctr, wheelL_ctr, last_speed_sampling
  'pins_init  
  dira[ODOM_R_PIN] := dira[ODOM_L_PIN] := IN

  stateR := ina[ODOM_R_PIN]
  stateL := ina[ODOM_L_PIN] 
  wheelR_ctr := 0
  wheelL_ctr := 0
  last_changeR := last_changeL := cnt - WHEEL_DEBOUNCE
  last_speed_sampling := cnt
  repeat    
    if ina[ODOM_R_PIN] <> stateR      
      if (cnt - last_changeR) > WHEEL_DEBOUNCE
        last_changeR := cnt
        wheelR_ctr++
        stateR := ina[ODOM_R_PIN]
    else
      last_changeR #>= (cnt - WHEEL_DEBOUNCE)
      
    if ina[ODOM_L_PIN] <> stateL      
      if (cnt - last_changeL) > WHEEL_DEBOUNCE
        last_changeL := cnt
        wheelL_ctr++
        stateL := ina[ODOM_L_PIN]
    else
      last_changeL #>= (cnt - WHEEL_DEBOUNCE)

    if (cnt - last_speed_sampling) > SPEED_SAMPLING_INTERVAL   
      long[speedL_ptr] :=  (4*100*wheelL_ctr)/MAX_TICKS_PER_S
      long[speedR_ptr] :=  (4*100*wheelR_ctr)/MAX_TICKS_PER_S
      wheelL_ctr := wheelR_ctr := 0
      last_speed_sampling := cnt
      
' this one returns, unlike the last one
PUB watch_wheel_in_cog(speedL_ptr_,speedR_ptr_) | stateL, stateR, last_changeR, last_changeL, wheelR_ctr, wheelL_ctr, last_speed_sampling, done
  'pins_init  
  dira[ODOM_R_PIN] := dira[ODOM_L_PIN] := IN

  stateR := ina[ODOM_R_PIN]
  stateL := ina[ODOM_L_PIN] 
  wheelR_ctr := 0
  wheelL_ctr := 0
  last_changeR := last_changeL := cnt - WHEEL_DEBOUNCE
  last_speed_sampling := cnt
  done := false
  repeat until done   
    if ina[ODOM_R_PIN] <> stateR      
      if (cnt - last_changeR) > WHEEL_DEBOUNCE
        last_changeR := cnt
        wheelR_ctr++
        stateR := ina[ODOM_R_PIN]
    else
      last_changeR #>= (cnt - WHEEL_DEBOUNCE)
      
    if ina[ODOM_L_PIN] <> stateL      
      if (cnt - last_changeL) > WHEEL_DEBOUNCE
        last_changeL := cnt
        wheelL_ctr++
        stateL := ina[ODOM_L_PIN]
    else
      last_changeL #>= (cnt - WHEEL_DEBOUNCE)

    if (cnt - last_speed_sampling) > SPEED_SAMPLING_INTERVAL   
      long[speedL_ptr_] :=  (4*100*wheelL_ctr)/MAX_TICKS_PER_S
      long[speedR_ptr_] :=  (4*100*wheelR_ctr)/MAX_TICKS_PER_S
      wheelL_ctr := wheelR_ctr := 0
      done := true
 
